#ifndef _BQUEUE_
#define _BQUEUE_ 
#include "memory.h"
#include "misc.h"
typedef intptr_t *BQUEUE;
BQUEUE bqueue_Create(MEMORY, unsigned);
void bqueue_Delete(MEMORY, BQUEUE);
void bqueue_Clean(BQUEUE);
intptr_t bqueue_GetCapacity(BQUEUE);
intptr_t bqueue_GetSum(BQUEUE);
BOOL bqueue_IsEmpty(BQUEUE);
BOOL bqueue_IsFull(BQUEUE);
BOOL bqueue_GetSize(BQUEUE);
intptr_t bqueue_GetFront(BQUEUE);
intptr_t bqueue_GetBack(BQUEUE);
void bqueue_Dequeue(BQUEUE);
void bqueue_BoundedEnqueue(BQUEUE, intptr_t);
void bqueue_Print(BQUEUE);
#endif
